Foreman - Bug #2321

Fail trying to create a new puppet class
03/14/2013 10:55 AM - Joost Ringoot

Status: Closed
Priority: Normal
Assignee:
Category: Puppet integration
Target version: 1.7.0
Difficulty: Fixed in Releases:
Triaged: Found in Releases:
Bugzilla link: Red Hat JIRA:
Pull request: https://github.com/theforeman/foreman/p
ull/1655
Description

Oops, we're sorry but something went wrong

x No route matches {:action=>"edit", :controller=>"puppetclasses", :id=>#<Puppetclass id: 1, name: "Centos 6.3 desktop",
created_at: "2013-03-14 14:51:24", updated_at: "2013-03-14 14:51:24">}

If you feel this is an error with Foreman itself, please open a new issue with Foreman ticketing system, You would probably need to
attach the Full trace and relevant log entries.

ActionController::RoutingError

No route matches {:action=>"edit", :controller=>"puppetclasses", :id=>#<Puppetclass id: 1, name: "Centos 6.3 desktop", created_at:
"2013-03-14 14:51:24", updated_at: "2013-03-14 14:51:24">}

app/helpers/application_helper.rb:110:in “link_to_if_authorized'

app/views/puppetclasses/index.html.erb:16:in *_app_views_puppetclasses_index_html_erb__ 2117896054_70066023223940_0'
app/views/puppetclasses/index.html.erb:14:in *_app_views_puppetclasses_index_html_erb_ 2117896054_70066023223940_0'
lib/foreman/thread_session.rb:31:in “clear_thread'

Related issues:
Has duplicate Foreman - Feature #6951: remove new puppet creation option Duplicate 08/06/2014

Associated revisions

Revision de19f5b9 - 10/06/2014 07:54 AM - Ohad Levy

fixes #2321 - remove new puppet creation option

History

#1 - 03/15/2013 08:36 AM - Joost Ringoot

| can not even see if there are still other classes (I think not) and | can't retry.
| always get the above error on this:
https://geppetto.oma.be/puppetclasses

#2 - 03/15/2013 09:18 AM - Greg Sutcliffe

That log seems to imply your have a class called "Centos 6.3 desktop" - is that true?

#3 - 03/16/2013 11:17 AM - Joost Ringoot
yes "Centos 6.3 desktop"

#4 - 03/16/2013 01:03 PM - Joost Ringoot

Yes Greg, like you told me on irc, it is most likely a input parser issue: should not allow spaces in classes.
For completeness, this is what is in the puppetclasses table is

[root@geppetto ~]# sqlite3 /usr/share/foreman/db/production.sqlite3

SQLite version 3.6.20

Enter ".help" for instructions

Enter SQL statements terminated with a ";"

sqlite> select * from puppetclasses;

1|Centos 6.3 desktop|2013-03-14 14:51:24.285593|2013-03-14 14:51:24.285593
https://geppetto.oma.be/puppetclasses

2|Centos 6.4 desktop|2013-03-14 15:02:00.350424|2013-03-14 15:02:00.350424
sqlite>

| understand, this is most likely bad puppet coding, | am just starting with it.

| thought

#5 - 03/16/2013 06:13 PM - Joost Ringoot

This resolved it greg, like you said: removing the spaces from the class nhames

sqlite> UPDATE puppetclasses SET name='Centos6base’' WHERE id="1";
sqlite> UPDATE puppetclasses SET name='Centos6desktop' WHERE id="2";

(It took me so long because | had to RTFM sqlite3, to know what command | needed)

#6 - 03/19/2013 04:41 AM - Dominic Cleal

- Status changed from New to Closed

Thanks for confirming. I'm going to close this, since spaces aren't supported in class names in Puppet.

#7 - 03/25/2013 07:13 AM - Greg Sutcliffe
- Status changed from Closed to New

- Target version set to 1.2.0

@Dominic - since they're not supported, we shouldn't allow a class to be manually created with a space in - i.e, we need to either drop manaul class
creation entirely, or add validations to the class names. Right now it's possible to totally break your classes page by creating a badly named class.
Re-opening.

#8 - 03/28/2013 04:38 AM - Ohad Levy
- Assignee deleted (Ohad Levy)

| didnt know we allow manually to create classes any more... but it does make sense to add more validation rules to the name (might slow down the
slow importer as well...)

#9 - 03/28/2013 06:19 AM - Greg Sutcliffe

To be honest, I'm fine with removing the manual class creation - it's so limited compared to the class importer, and the class needs to exist for puppet
to apply it, so you may as well import it.

#10 - 03/28/2013 06:23 AM - Ohad Levy

afair, its removed already

#11 - 03/28/2013 06:46 AM - Greg Sutcliffe

| can still create classes in the Ul on latest develop. We need to either drop the "New Puppetclass" button/functionality or validate the class name in
the same way as puppet does.

#12 - 05/10/2013 05:19 AM - Dominic Cleal

- Target version changed from 1.2.0 to 1.3.0

#13 - 09/16/2013 12:28 PM - Lukas Zapletal

- Target version changed from 1.3.0 to 1.4.0

#14 - 10/16/2013 03:38 PM - Greg Sutcliffe
- Target version deleted (1.4.0)

#15 - 08/06/2014 04:33 AM - Dominic Cleal

- Has duplicate Feature #6951: remove new puppet creation option added

#16 - 08/06/2014 06:10 AM - The Foreman Bot
- Status changed from New to Ready For Testing

- Target version setto 1.7.5
http://docs.puppetlabs.com/puppet/3/reference/lang_reserved.html#classes-and-types

- Pull request https://github.com/theforeman/foreman/pull/1655 added

#17 - 08/14/2014 06:27 AM - Dominic Cleal

For the record, a conversation on #theforeman about retaining the functionality due to poor import performance:

105713 < deu_> Dominic: many thanks for advice, importing the classes from puppet fixed the issue and created 25k records in
environment_classes. now, will i be able to still add a puppetclass via gui/api that will work manually without import ? import process takes too long
105759 < Dominic> the API will probably still continue to work, but the environment list in the Ul is greyed out IIRC and may be removed entirely in
1.7

110240 < deu_> Dominic: i have tested adding a bogus class, and it create record in puppetclasses, but not environment_classes did not add a
record so that means a new class wont be functional. is this really intended ? it seems quite a bug to me, or i missed something ?

110340 < Dominic> maybe, but the Ul isn't really intended for use (which is why it's being removed). You should be able to specify environments on
the API if you want to use that, which I think should create environment_classes.

111230 < deu_> Dominic: Interesting news and thanks for clarification. We can stick with curl or hammer for adding a puppet classes (because import
from puppetmaster takes too long), but GUI is still convenient for some so in my opinion should still function for such basic functionality

#18 - 08/20/2014 06:48 AM - Anonymous

- Target version changed from 1.7.5t0 1.7.4

#19 - 09/10/2014 07:18 AM - Anonymous

- Target version changed from 1.7.4 to 1.7.3

#20 - 09/30/2014 10:31 AM - Dominic Cleal

- Target version changed from 1.7.3 to 1.7.2

#21 - 10/06/2014 08:03 AM - Ohad Levy
- Status changed from Ready For Testing to Closed
- % Done changed from 0 to 100

Applied in changeset de19f5b9027e14fdecfb52d75dee0bd694b02265.

#22 - 10/07/2014 03:34 AM - Daniel Lobato Garcia

- translation missing: en.field_release set to 21
